
import 'package:cloud_firestore/cloud_firestore.dart';

import '../../abg_utils.dart';

List<ProductData> cart = [];
ProviderData? cartCurrentProvider;
bool cartAnyTime = true;
var cartSelectTime = DateTime.now();
String cartHint = "";
String cartCouponCode = "";
/*
вся информация в price.dart:
String couponId = "";     // 2746fde7643fgd
String couponCode = "";   // CODE25
String discountType = ""; // "percent" or "fixed"
double discount = 0;      // 12
 */

clearCart(){
  cartCouponCode = "";
  cartHint = "";
  cartAnyTime = true;
  cartSelectTime = DateTime.now();
  couponId = "";     // 2746fde7643fgd
  couponCode = "";   // CODE25
  discountType = ""; // "percent" or "fixed"
  discount = 0;      // 12
}

// List<String> checkout = []; // provider id

String? addToCart(ProductData service,
    String stringAlreadyInCart  /// strings.get(210) /// This service already in the cart
    ){
  for (var item in cart)
    if (item.id == service.id)
      return stringAlreadyInCart;
  cart.add(ProductData.clone(service));
  _cartSave();
}

removeFromCart(ProductData service){
  for (var item in cart)
    if (item.id == service.id){
      cart.remove(item);
      _cartSave();
      return;
    }
}

_cartSave(){
  //userAccountData.cartList = [];
  // for (var item in cart)
  //   userAccountData.cartList.add(item.id);
  // User? user = FirebaseAuth.instance.currentUser;
  // if (user == null)
  //   return "user == null";
  // FirebaseFirestore.instance.collection("listusers").doc(user.uid).set({
  //   "cartList": userAccountData.cartList,
  // }, SetOptions(merge:true));
  // redrawMainWindow();
}

initCart(){
  // lastBookingId = "";
  // if (_init)
  //   return;
  // _init = true;
  // for (var providerId in userAccountData.cartList){
  //   for (var service in product)
  //     if (service.id == providerId) {
  //       bool _found = false;
  //       for (var item in cart )
  //         if (item.id == service.id)
  //           _found = true;
  //       if (!_found)
  //         cart.add(service);
  //     }
  // }
}

_removeCheckoutFromCart(){
  for (var item in userAccountData.cartList)
    for (var service in cart)
      if (service.id == item){
        cart.remove(service);
        break;
      }
  _cartSave();
}

// _allCheckout(){
//   checkout = [];
//   for (var item in cart)
//     if (item.providers.isNotEmpty)
//       checkout.add(item.providers[0]);
// }

checkoutProvider(ProviderData provider){
  cartCurrentProvider = provider;
  // checkout = [];
  // for (var item in cart)
  //   if (item.providers.isNotEmpty)
  //     if (item.providers[0] == provider.id)
  //       checkout.add(item.providers[0]);
}

String cartLastAddedId = "";

cartFinish(OrderData _data) async{
  Map<String, dynamic> d = _data.toJson();
  var t = await FirebaseFirestore.instance.collection("booking").add(d);
  cartLastAddedId = t.id;
  _data.id = t.id;
  await bookingSaveInCache(_data);

  await FirebaseFirestore.instance.collection("settings").doc("main")
      .set({"booking_count": FieldValue.increment(1)}, SetOptions(merge:true));
  await FirebaseFirestore.instance.collection("settings").doc("main")
      .set({"booking_count_unread": FieldValue.increment(1)}, SetOptions(merge:true));
  _clearCart();
}

_clearCart(){
  List<ProductData> list = [];
  for (var service in cart){
    if (cartCurrentProvider != null && service.providers.isNotEmpty)
      if (service.providers[0] != cartCurrentProvider!.id){
        list.add(service);
      }
  }
  cart = list;
}

List<ProductData> cartGetProductsForBooking(){
  List<ProductData> list = [];
  for (var service in cart){
    if (cartCurrentProvider != null && service.providers.isNotEmpty)
      if (service.providers[0] == cartCurrentProvider!.id){
        list.add(service);
      }
  }
  return list;
}

String cartGetImage(){
  for (var service in cart){
    if (cartCurrentProvider != null && service.providers.isNotEmpty)
      if (service.providers[0] == cartCurrentProvider!.id){
        if (service.gallery.isNotEmpty)
          return service.gallery[0].serverPath;
      }
  }
  return "";
}

List<String> _cartGetProviders(){
  List<String> ret = [];
  for (var item in cart)
    if (item.providers.isNotEmpty)
      if (!ret.contains(item.providers[0]))
        ret.addAll(item.providers);
  return ret;
}

List<ProviderData> cartGetProvidersData(){
  List<ProviderData> ret = [];
  List<String> list = _cartGetProviders();
  for (var item in list){
    var t = getProviderById(item);
    if (t != null)
      ret.add(t);
  }
  return ret;
}

List<PriceForCardData> cartGetPriceForAllServices(){
  List<PriceForCardData> list = [];

  for (var service in cart){
    if (cartCurrentProvider != null && service.providers.isNotEmpty)
      if (service.providers[0] == cartCurrentProvider!.id){
        if (service.thisIsArticle){
          currentArticle = service;
          double _price = 0;
          var t = articleGetTotalPrice();
          double _withoutCount = 0;
          if (t != null) {
            _price = t * service.countProduct;
            _withoutCount = t;
          }
          var name = articleGetFullName();
          list.add(PriceForCardData(
              priceWithCount: _price,
              priceWithoutCount: _withoutCount,
              priceAddons: 0,
              subTotal: _price,
              name: name,
              priceString: getPriceString(_price),
              priceAddonsString: getPriceString(0),
              subTotalString: getPriceString(_price),
              isArticle: true,
              count: service.countProduct,
              priceWithoutCountString: getPriceString(_withoutCount),
              tax: _price*service.tax/100,
              taxPercentage: service.tax,
              addonText: "",
              image: service.gallery.isNotEmpty ? service.gallery[0].serverPath : "",
          ));
        }else{
          countProduct = service.countProduct;
          setDataToCalculate(null, service);

          var _price = getCostWidthCount();
          var addons = getAddonsTotal();
          var name = getTextByLocale(service.name, locale) + " " + getTextByLocale(price.name, locale);

          var _tax = (_price+addons)*service.tax/100;
          String _addonText = "";
          for (var item in service.addon)
            _addonText += "${getTextByLocale(item.name, locale)} ${item.needCount} x ${getPriceString(item.price)}\n";

          list.add(PriceForCardData(
              priceWithCount: _price,
              priceWithoutCount: getCost(),
              priceAddons: addons,
              subTotal: _price+addons,
              name: name,
              priceString: getPriceString(_price),
              priceAddonsString: getPriceString(addons),
              subTotalString: getPriceString(_price+addons),
              isArticle: false,
              count: service.countProduct,
              priceWithoutCountString: getPriceString(getCost()),
              tax: _tax,
              taxPercentage: service.tax,
              addonText: _addonText,
              image: service.gallery.isNotEmpty ? service.gallery[0].serverPath : "",
          ));
        }
      }
  }

  return list;
}

PriceTotalForCardData cartGetTotalForAllServices() {
  return cartGetTotalForAllServices2(cart);
}

PriceTotalForCardData cartGetTotalForAllServices2(List<ProductData> _cart) {
  double subtotal = 0;
  double coupon = 0;
  double tax = 0;
  double total = 0;
  double toAdmin = 0;
  for (var service in _cart){
    if (cartCurrentProvider != null && service.providers.isNotEmpty)
      if (service.providers[0] == cartCurrentProvider!.id){
        if (service.thisIsArticle){
          currentArticle = service;
          var t = articleGetTotalPrice();
          if (t != null) {
            t *= service.countProduct;
            var _tax = service.tax/100*t;
            subtotal += t;
            tax += _tax;
            total += (t+_tax);
            toAdmin += (getSubTotal()*service.taxAdmin/100);
          }
        }else{
          countProduct = service.countProduct;
          setDataToCalculate(null, service);
          subtotal += getSubTotal();
          coupon += getCoupon();
          tax += getTax();
          total += getTotal();
          toAdmin += (getSubTotal()*service.taxAdmin/100);
        }
    }
  }
  return PriceTotalForCardData(subtotal, coupon, toAdmin, tax, total,
    getPriceString(coupon),
    getPriceString(tax),
    getPriceString(total),
  );
}

class PriceForCardData{
  final String name;
  final int count;
  final double priceWithoutCount;
  final double priceWithCount;
  final double priceAddons;
  final double subTotal;
  final double tax;
  final String priceString;
  final String priceAddonsString;
  final String subTotalString;
  final String priceWithoutCountString;
  final bool isArticle;
  final double taxPercentage;
  final String addonText;
  final String image;
  PriceForCardData({required this.priceWithCount, required this.priceWithoutCount, required this.priceAddons,
    required this.subTotal, required this.name, required this.priceString, required this.priceAddonsString,
    required this.subTotalString, required this.isArticle, required this.count, required this.priceWithoutCountString,
    required this.tax, required this.taxPercentage, required this.addonText, required this.image});
}

class PriceTotalForCardData{
  final double subtotal;
  final double discount;
  final double toAdmin;
  final double tax;
  final double total;
  final String discountString;
  final String taxString;
  final String totalString;
  PriceTotalForCardData(this.subtotal, this.discount, this.toAdmin, this.tax, this.total,
      this.discountString, this.taxString, this.totalString);
}

